<template>
  <div class="full-page bg" element-loading-text="数据加载中..." element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(255,255,255, 0.5)" v-loading.fullscreen.lock="markLoading">
    <div class="search-container">
      <el-form ref="form" :model="searchForm" label-width="auto">
        <el-row :gutter="20">
          <el-col :span="7">
            <el-form-item label="改革事项">
              <el-input v-model="searchForm.effectCardTopic" clearable placeholder="请输入改革事项"></el-input>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="5">
            <el-form-item label="所属领域">
              <dict-select dictCode="ggbb_ssly" :hasDefaultOption="true" clearable v-model="searchForm.effectField"
                style="width: 100%" @select="(val, obj) => hanldeCommonSelect(val, obj, 'serch')"
                placeholder="请选择所属领域" />
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="所属跑道">
              <el-select v-model="searchForm.effectRunway" style="width: 100%" clearable placeholder="请选择所属跑道">
                <el-option v-for="item in demandRunwaOoptionsSerch" :key="item.value" :label="item.name"
                  :value="item.value">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col> -->
          <el-col :span="7">
            <el-form-item label="专项小组">
              <dict-select dictCode="zxxz" :hasDefaultOption="true" clearable v-model="searchForm['group_Name_']"
                style="width: 100%" placeholder="请选择专项小组" />
            </el-form-item>
          </el-col>
          <el-col :span="7">
            <el-form-item label="审核状态">
              <dict-select dictCode="sjcxls_shzt" :hasDefaultOption="true" clearable v-model="searchForm['r.status_']"
                style="width: 100%" placeholder="请选择审核状态" />
            </el-form-item>
          </el-col>
          <el-col :span="2">
            <el-button icon="el-icon-search" type="primary" class="btn btn-plus" @click="handleSearch">
              {{ this.$t('common.search') }}
            </el-button>
          </el-col>
        </el-row>
      </el-form>
    </div>
    <el-row :gutter="10" class="main-table-container flex">
      <el-col :span="24" class="table-container" ref="contentPanel" style="padding: 20px">
        <div style="margin-bottom: 10px" ref="btnPanel">
          <el-button icon="el-icon-plus" type="primary" class="btn btn-plus" @click="handleAdd">
            {{ this.$t('common.add') }}
          </el-button>
          <el-button slot="reference" icon="el-icon-delete" type="danger" class="btn btn-delete" :disabled="!deleteIds"
            @click="handleDelete">
            {{ this.$t('common.delete') }}
          </el-button>
        </div>
        <div :style="{ width: '100%', height: `${tableMaxHeight}` + 'px' }">
          <el-table stripe size="mini" v-loading="tableLoading" ref="multipleSelection" :data="tableData"
            :max-height="tableMaxHeight" :style="{
              width: '100%',
              height: `${tableMaxHeight}` + 'px',
            }" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" :selectable="selectable"></el-table-column>
            <el-table-column type="index" width="55" label="序号" align="center">
            </el-table-column>
            <el-table-column prop="effectCardTopic" show-overflow-tooltip min-width="280" align="center" label="改革事项">
            </el-table-column>
            <el-table-column prop="groupName" show-overflow-tooltip min-width="200" align="center" label="专项小组">
            </el-table-column>
            <!-- <el-table-column prop="effectField" show-overflow-tooltip min-width="100" align="center" label="所属领域">
              <template v-slot="{ row }">
                {{ getDictName('ggbb_ssly', row.effectField) }}
              </template>
</el-table-column>
<el-table-column prop="effectRunway" show-overflow-tooltip min-width="100" align="center" label="所属跑道">
  <template v-slot="{ row }">
                {{ getDictName('ggbb_sspd', row.effectRunway) }}
              </template>
</el-table-column> -->
            <el-table-column prop="createTime" show-overflow-tooltip min-width="100" align="center" label="提交审核时间">
              <template v-slot="{ row }">
                {{ row.createTime && row.createTime.split(' ')[0] }}
              </template>
            </el-table-column>
            <el-table-column show-overflow-tooltip width="140" align="center" label="审核状态">
              <template v-slot="{ row }">
                <el-tag :type="getTagType(row.status)">
                  {{ getDictName('sjcxls_shzt', row.status) }}
                </el-tag>
              </template>
            </el-table-column>
            <el-table-column min-width="160" align="center" fixed="right" label="操作">
              <template v-slot="{ row }">
                <el-link v-if="row.status == 0" icon="el-icon-s-check" type="primary" :underline="false"
                  class="cloumn-btn" @click="handleUpdateStatus(row, 1)">
                  上报
                </el-link>
                <el-link v-if="row.status == 0 || row.status == 2 || row.status == 4 || row.status == 6"
                  icon="el-icon-edit" type="primary" :underline="false" class="cloumn-btn" @click="handleDbClick(row)">
                  编辑
                </el-link>
                <el-link v-else icon="el-icon-view" type="primary" :underline="false" class="cloumn-btn"
                  @click="handleDetail(row)">
                  详情
                </el-link>
                <el-link v-if="row.status == 1" icon="el-icon-refresh-left" type="danger" :underline="false"
                  class="cloumn-btn wait-updata-btn" @click="handleUpdateStatus(row, 0)">
                  撤回
                </el-link>
              </template>
            </el-table-column>
          </el-table>
        </div>
        <effectDialog ref="effectDialog" @refreshData="refreshData"></effectDialog>
        <pagination ref="paginationPanel" style="margin-top: 10px" :pageResult="pageResult"
          @size-change="handleSizeChange" @current-change="handleCurrentChange" />
      </el-col>
    </el-row>
  </div>
</template>

<script>
import pagination from '@/components/pagination'
import { TableMixin } from '@/mixins/tableMixin'
import req from '@/request.js'
import utils from '@/utils.js'
import effectDialog from './dialog/effectDialog.vue'
import apiLsit from '@/api/effect'
const portal = window.context.portal
export default {
  name: 'cityReformSchoolEntry',
  components: {
    pagination,
    effectDialog,
  },
  mixins: [TableMixin],
  data() {
    return {
      tableMaxHeight: 400,
      loading: false,
      tableLoading: false,
      tableData: [],
      multipleSelection: [],
      params: {
        pageBean: {
          page: 1,
          pageSize: 20,
          total: 0,
        },
        querys: [
          {
            group: 'main',
            operation: 'IN',
            property: 'r.effect_Form_',
            relation: 'AND',
            value: [1, 2],
          },
        ],
      },
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0,
      },
      searchForm: {}, // 顶部搜索对象
      deleteIds: '', // 是否选中列表解锁删除按钮
      isAppear: false,
      markLoading: false
    }
  },

  created() {
    this.loadData(this.params)
  },
  methods: {
    selectable(row) {
      return row.status % 2 === 0
    },
    getTagType(status) {
      return status < 1 ? 'info' : status == 7 ? 'success' : status % 2 === 0 ? 'danger' : ''
    },
    //获取数据
    loadData(params) {
      this.tableLoading = true
      apiLsit.getCItyTableData(false, '', params, (res) => {
        this.tableLoading = false
        this.tableData = res.rows || []
        this.pageResult = {
          page: res.page,
          pageSize: res.pageSize,
          total: res.total,
        }
      })
    },

    refreshData() {
      this.loadData(this.params)
    },

    getDictName(code, value) {
      return utils.getDictName(code, value)
    },

    //添加
    handleAdd() {
      this.$refs.effectDialog.openDialog('', '新增', '市级')
    },
    handleDetail(row) {
      this.$refs.effectDialog.openDialog(row, '详情', '市级')
    },
    //修改
    handleDbClick(row) {
      this.$refs.effectDialog.openDialog(row, '编辑', '市级')
    },
    // 驳回
    handleUpdateStatus(row, status) {
      let msg = status ? '提交上报' : '撤回为草稿'
      let type = status ? 'success' : 'error'
      this.$confirm(`确定${msg}吗？`, this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type,
      }).then(() => {
        this.markLoading = true
        let data = {
          effectId: row.id,
          id: row.effectivenessId,
          status
        }
        if (!status) {
          data.approvalResults = 2
        }
        apiLsit.updateSatusById(data, res => {
          if (res.state) {
            this.$message.success(`${msg}成功`)
            this.loadData(this.params)
          }
          this.markLoading = false
        })
      })
    },
    // 删除子表数据
    handleDelete_(id) {
      this.$confirm('确定删除此数据', this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning',
      }).then(() => {
        this.loading = true
        req
          .remove(portal + '/bizEffectEffectiveness/v1/?ids=' + id)
          .then((res) => {
            this.loading = false
            this.dialog.visible = false
            this.loadData(this.params)
          })
      })
    },
    // 删除主表数据
    handleDelete(id) {
      this.$confirm('确定删除此数据', this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'error',
      }).then(() => {
        // this.loading = true
        req
          .remove(portal + '/fill/bizCityEffectDryingCompetition/v1/?ids=' + this.deleteIds)
          .then((res) => {
            this.$message.success('数据删除成功')
            // this.loading = false
            // this.dialog.visible = false
            this.loadData(this.params)
          })
      })
    },
    // 上报
    handleAppear() {
      this.$confirm('确认上报吗？', this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning',
      }).then(() => {
        this.isAppear = true
        this.loading = true
        let data = this.dialogForm.records[0]
        data.status = 1
        req
          .post(
            portal + '/bizEffectDryingCompetition/v1/updateAuditStatus',
            data
          )
          .then((res) => {
            if (res.data.state) {
              this.$message.success('上报成功')
              this.dialog.visible = false
            } else {
              this.$message.error('上报失败')
            }
            this.loading = false
            this.dialog.visible = false
            this.loadData(this.params)
          })
      })
    },
    // 顶部搜索
    handleSearch() {
      let obj = this.searchForm
      let querys = [
        {
          group: 'main',
          operation: 'IN',
          property: 'r.effect_Form_',
          relation: 'AND',
          value: [1, 2],
        },
      ]
      for (let i in obj) {
        if (obj[i]) {
          querys.push({
            group: 'main',
            operation: i == 'effectCardTopic' ? 'LIKE' : 'EQUAL',
            parentGroup: '',
            property: i,
            relation: 'AND',
            value: obj[i],
          })
        }
      }
      this.params.querys = querys
      this.params.pageBean.page = 1
      this.loadData(this.params)
    },
    // 弹层关闭
    handleDialogClose() {
      this.dialog.visible = false
    },
    handleSelectionChange(currentData) {
      console.log(currentData);
      if (currentData.length === 0) return (this.deleteIds = '')
      let ids = []
      currentData.forEach((item) => {
        ids.push(item.id)
      })
      this.deleteIds = ids.join(',')
    },
    handleCurrentChange(page) {
      this.params.pageBean = { ...this.params.pageBean, page }
      this.loadData(this.params)
    },
    handleSizeChange(pageSize) {
      this.params.pageBean = { ...this.params.pageBean, pageSize }
      this.loadData(this.params)
    },
  },
}
</script>

<style lang="scss" scoped>
.common-tree-container {
  height: calc(100% - 70px);
  margin-top: 0.52083vw;
  padding: 1.04167vw 1.04167vw;
  background-color: #fff;
  position: relative;
  box-sizing: border-box;
  overflow-y: auto;
  border-radius: 20px;
  box-shadow: 0px 0px 0.625vw 0 rgba(92, 102, 83, 0.2);
}

.container-head {
  display: flex;
  align-items: center;

  i {
    font-size: 16px;
    margin-left: 5px;
    font-weight: 600;
    cursor: pointer;
  }
}

.move-tree /deep/ .el-tree {
  height: 90%;
  overflow-y: auto;
  border: none;
}

.cloumn-btn {
  border: 1px solid #2761ff;
  padding: 3px 10px;
  border-radius: 5px;

  &:nth-child(1) {
    margin-right: 5px;
  }

  &:nth-child(1):hover {
    background-color: #2761ff;
    color: #fff;
  }

  &:nth-child(2):hover {
    background-color: #2761ff;
    color: #fff;
  }

  // &:nth-child(2):hover {
  //   background-color: #f56c6c;
  //   color: #fff;
  //   border-color: #f56c6c;
  // }
  /deep/ i,
  span {
    font-size: 16px;
  }
}

.wait-updata-btn {
  border: 1px solid #f56c6c;
  margin-left: 5px;
  padding: 3px 10px;
  border-radius: 5px;

  &:hover {
    background-color: #f56c6c !important;
    color: #fff !important;
    border-color: #f56c6c !important;
  }
}

/deep/ .el-tree-node__content {
  padding: 5px 0;
}

/deep/ .el-divider--horizontal {
  margin: 0;
}

.h2-title {
  font-size: 18px;
  margin: 0;
  padding: 0;
}

.detils-item {
  box-sizing: border-box;
  padding: 10px;
  position: relative;
  cursor: pointer;
  border: 1px dashed #fff;

  // &:hover {
  //   border: 1px dashed #2761ff;
  //   .add-del-btn {
  //     display: block;
  //   }
  // }
  .add-del-btn {
    position: absolute;
    display: none;
    right: 10px;
    top: 10px;
    z-index: 9999;
  }
}

.add-btn {
  font-weight: bold;
  cursor: pointer;
  color: #2761ff;
  font-size: 16px;
}

.del-btn {
  font-size: 16px;
  font-weight: bold;
  margin-left: 10px;
  color: #f56c6c;
  cursor: pointer;
}

.upload_file {
  opacity: 1;
  pointer-events: auto;
  transition: opacity 0.3s;
}

.upload_file_none {
  opacity: 0;
  pointer-events: none;
  transition: opacity 0.3s;
}
</style>